Codeforces Round #274 (Div. 2) Riding in a Lift(DP 前缀和)

Riding in a Lift
time limit per test
2 seconds
memory limit per test
256 megabytes
input
standard input
output
standard output

Imagine that you are in a building that has exactly n floors. You can move between the floors in a lift. Let's number the floors from bottom to top with integers from 1 to n. Now you're on the floor number a. You are very bored, so you want to take the lift. Floor number b has a secret lab, the entry is forbidden. However, you already are in the mood and decide to make k consecutive trips in the lift.

Let us suppose that at the moment you are on the floor number x (initially, you were on floor a). For another trip between floors you choose some floor with number y (y ≠ x) and the lift travels to this floor. As you cannot visit floor b with the secret lab, you decided that the distance from the current floor x to the chosen y must be strictly less than the distance from the current floor x to floor b with the secret lab. Formally, it means that the following inequation must fulfill: |x - y| < |x - b|. After the lift successfully transports you to floor y, you write down number y in your notepad.

Your task is to find the number of distinct number sequences that you could have written in the notebook as the result of k trips in the lift. As the sought number of trips can be rather large, find the remainder after dividing the number by 1000000007 (109 + 7).

Input

The first line of the input contains four space-separated integers nabk (2 ≤ n ≤ 5000, 1 ≤ k ≤ 5000, 1 ≤ a, b ≤ na ≠ b).

Output

Print a single integer — the remainder after dividing the sought number of sequences by 1000000007 (109 + 7).

Examples
input
5 2 4 1
output
2
input
5 2 4 2
output
2
input
5 3 4 1
output
0
Note

Two sequences p1, p2, ..., pk and q1, q2, ..., qk are distinct, if there is such integer j (1 ≤ j ≤ k), that pj ≠ qj.

Notes to the samples:

  1. In the first sample after the first trip you are either on floor 1, or on floor 3, because |1 - 2| < |2 - 4| and |3 - 2| < |2 - 4|.
  2. In the second sample there are two possible sequences: (1, 2); (1, 3). You cannot choose floor 3 for the first trip because in this case no floor can be the floor for the second trip.
  3. In the third sample there are no sought sequences, because you cannot choose the floor for the first trip.

【题意】有一n层楼的楼房,可坐电梯上下。初始位置在a层,b层楼门无法打开,所以无法到达。如果你当前在x层,你能走到y层当且仅当|x - y| < |x - b|.

每一次有效的移动可到达一个楼层,然后把楼层号写下,连续的移动就可写下一个序列。

问经过k次连续的移动后,产生的序列种数。

【分析】DP。dp[i][j]表示第j次移动到达i层楼的序列数,dp[i][j]=∑(dp[能够到达i层楼的楼层][j-1])%mod。所以这里需要求一个前缀和,然后去掉dp[i][j-1]。

#include <bits/stdc++.h>
#define pb push_back
#define mp make_pair
#define vi vector<int>
#define inf 0x3f3f3f3f
#define met(a,b) memset(a,b,sizeof a)
using namespace std;
typedef long long LL;
const int N = 5e3+50;
const int mod = 1e9+7;
int n,a,b,k;
LL dp[N][N],sum[N];
int main(){
    scanf("%d%d%d%d",&n,&a,&b,&k);
    dp[a][0]=1;
    for(int i=1;i<=n;i++){
        sum[i]=(sum[i-1]+dp[i][0])%mod;
    }
    for(int j=1;j<=k;j++){
        for(int i=1;i<=n;i++){
            if(i>b){
                int low=(i+b)/2;
                int up=n;
                dp[i][j]=((sum[up]-sum[low]+mod)%mod-dp[i][j-1]+mod)%mod;
            }
            else if(i<b){
                int low=0;
                int up=(i+b)&1==1?(i+b)/2:(i+b)/2-1;;
                dp[i][j]=((sum[up]-sum[low]+mod)%mod-dp[i][j-1]+mod)%mod;
            }
            //printf("i:%d j:%d dp:%lld\n",i,j,dp[i][j]);
        }
        sum[0]=0;
        for(int i=1;i<=n;i++){
            sum[i]=(sum[i-1]+dp[i][j])%mod;
        }
    }
    LL ans=0;
    for(int i=1;i<=n;i++)ans=(ans+dp[i][k])%mod;
    printf("%lld\n",ans);
    return 0;
}

 

posted @ 2017-07-23 22:03  贱人方  阅读(299)  评论(0编辑  收藏  举报